commit 6174a64226b67a1bc05a6046525e672b60028f12
Author: freddy77 <freddy77>
Date:   Thu Nov 26 09:07:27 2009 +0000

    Fix univarchar in Sybase servers

diff --git a/ChangeLog b/ChangeLog
index 3d8adf6..725255a 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Thu Nov 26 10:06:51 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds.h src/tds/data.c src/tds/tds_checks.c:
+	* src/tds/tds_checks.h src/tds/token.c:
+	- Fix univarchar in Sybase servers
+
 Tue Nov 24 16:48:17 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/config.c: small optimization
 
@@ -1907,4 +1912,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2887 2009/11/24 15:48:52 freddy77 Exp $
+$Id: ChangeLog,v 1.2888 2009/11/26 09:07:27 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index 12278b8..61c2280 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.321 2009/08/25 14:25:35 freddy77 Exp $ */
+/* $Id: tds.h,v 1.322 2009/11/26 09:07:28 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -1425,7 +1425,7 @@ unsigned char *tds7_crypt_pass(const unsigned char *clear_pass, size_t len, unsi
 TDSDYNAMIC *tds_lookup_dynamic(TDSSOCKET * tds, const char *id);
 /*@observer@*/ const char *tds_prtype(int token);
 int tds_get_varint_size(TDSSOCKET * tds, int datatype);
-int tds_get_cardinal_type(int datatype);
+int tds_get_cardinal_type(int datatype, int usertype);
 
 
 
diff --git a/src/tds/data.c b/src/tds/data.c
index c9a5866..475a733 100644
--- a/src/tds/data.c
+++ b/src/tds/data.c
@@ -35,7 +35,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: data.c,v 1.24 2009/08/26 12:32:11 freddy77 Exp $");
+TDS_RCSID(var, "$Id: data.c,v 1.25 2009/11/26 09:07:28 freddy77 Exp $");
 
 /**
  * Set type of column initializing all dependency 
@@ -47,7 +47,7 @@ tds_set_column_type(TDSSOCKET * tds, TDSCOLUMN * curcol, int type)
 {
 	/* set type */
 	curcol->on_server.column_type = type;
-	curcol->column_type = tds_get_cardinal_type(type);
+	curcol->column_type = tds_get_cardinal_type(type, curcol->column_usertype);
 
 	/* set size */
 	curcol->column_cur_size = -1;
@@ -152,7 +152,7 @@ tds_set_param_type(TDSSOCKET * tds, TDSCOLUMN * curcol, TDS_SERVER_TYPE type)
 }
 
 int
-tds_get_cardinal_type(int datatype)
+tds_get_cardinal_type(int datatype, int usertype)
 {
 	switch (datatype) {
 	case XSYBVARBINARY:
@@ -169,6 +169,13 @@ tds_get_cardinal_type(int datatype)
 		return SYBCHAR;
 	case SYB5INT8:
 		return SYBINT8;
+	case SYBLONGBINARY:
+		switch (usertype) {
+		case USER_UNICHAR_TYPE:
+		case USER_UNIVARCHAR_TYPE:
+			return SYBTEXT;
+		}
+		break;
 	}
 	return datatype;
 }
diff --git a/src/tds/tds_checks.c b/src/tds/tds_checks.c
index e24f4e1..eae34a4 100644
--- a/src/tds/tds_checks.c
+++ b/src/tds/tds_checks.c
@@ -44,7 +44,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: tds_checks.c,v 1.28 2009/10/02 09:24:08 freddy77 Exp $");
+TDS_RCSID(var, "$Id: tds_checks.c,v 1.29 2009/11/26 09:07:28 freddy77 Exp $");
 
 #if ENABLE_EXTRA_CHECKS
 
@@ -197,7 +197,7 @@ tds_check_column_extra(const TDSCOLUMN * column)
 	SPECIAL(SYBTEXT, XSYBVARCHAR, 8)
 	SPECIAL(SYBTEXT, XSYBNVARCHAR, 8)
 	SPECIAL(SYBIMAGE, XSYBVARBINARY, 8)
-	assert(tds_get_cardinal_type(column->on_server.column_type) == column->column_type
+	assert(tds_get_cardinal_type(column->on_server.column_type, column->column_usertype) == column->column_type
 		|| (tds_get_null_type(column->column_type) == column->on_server.column_type
 		&& column->column_varint_size == 1 && is_fixed_type(column->column_type)));
 
diff --git a/src/tds/tds_checks.h b/src/tds/tds_checks.h
index 0d50055..bbb474c 100644
--- a/src/tds/tds_checks.h
+++ b/src/tds/tds_checks.h
@@ -20,7 +20,7 @@
 #ifndef TDS_CHECKS_H
 #define TDS_CHECKS_H
 
-/* $Id: tds_checks.h,v 1.4 2008/12/09 09:39:14 freddy77 Exp $ */
+/* $Id: tds_checks.h,v 1.5 2009/11/26 09:07:28 freddy77 Exp $ */
 #if defined(__GNUC__) && __GNUC__ >= 4
 #pragma GCC visibility push(hidden)
 #endif
@@ -48,9 +48,6 @@ void tds_check_column_extra(const TDSCOLUMN * column);
 void tds_check_resultinfo_extra(const TDSRESULTINFO * res_info);
 void tds_check_cursor_extra(const TDSCURSOR * cursor);
 void tds_check_dynamic_extra(const TDSDYNAMIC * dynamic);
-
-int tds_get_cardinal_type(int datatype);
-int tds_get_varint_size(TDSSOCKET * tds, int datatype);
 #endif
 
 #if defined(__GNUC__) && __GNUC__ >= 4
diff --git a/src/tds/token.c b/src/tds/token.c
index f1de333..fa9ae14 100644
--- a/src/tds/token.c
+++ b/src/tds/token.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: token.c,v 1.375 2009/09/03 11:53:47 freddy77 Exp $");
+TDS_RCSID(var, "$Id: token.c,v 1.376 2009/11/26 09:07:28 freddy77 Exp $");
 
 #define USE_ICONV tds->use_iconv
 
@@ -2067,7 +2067,7 @@ tds7_get_variant(TDSSOCKET * tds, TDSCOLUMN * curcol)
 				return TDS_FAIL;
 			if (tds_get_char_data(tds, (char *) v->data, colsize, curcol) == TDS_FAIL)
 				return TDS_FAIL;
-			v->type = tds_get_cardinal_type(type);
+			v->type = tds_get_cardinal_type(type, 0);
 		} else {
 			v->data = (TDS_CHAR*) malloc(colsize);
 			if (!v->data)

